package objectdbevaluation;

import java.util.concurrent.atomic.AtomicInteger;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import com.objectdb.o.UserException;

public class EntityWriteDAO {

    private EntityManager manager;
    private EntityManagerFactory factory;
    private AtomicInteger writeCounter;

    public void initialize() {

        if(manager == null) {
            manager = factory.createEntityManager();
        }
    }

    public void shutdown() {
        manager.close();
        manager = null;
    }

    public void writeObject(TestEntity entity) {

        try {

            if(manager.isOpen()) {
                manager.getTransaction().begin();
                manager.persist(entity);
                manager.getTransaction().commit();
                if(writeCounter.incrementAndGet() % 500 == 0) {
                    manager.flush();
                }

                if(writeCounter.get() % 1000 == 0) {
                    System.out.println("Entities written: " + writeCounter.get());
                }
            }
        } catch (UserException e) {
            System.out.println("Exception occurred in object db during write!");
        }
    }

    public void setFactory(EntityManagerFactory factory) {
        this.factory = factory;
    }

    public void setWriteCounter(AtomicInteger writeCounter) {
        this.writeCounter = writeCounter;
    }
}
