package objectdbevaluation;

import java.util.HashMap;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.OneToOne;

@Entity
public class TestEntity {

    @Id private int firstId;
    @Id private String secondId;

    @OneToOne(cascade=CascadeType.ALL)
    private HashMap<String, TestEmbeddableA> myMap = new HashMap<String, TestEmbeddableA>();

    public Object getObject(String key1, String key2, String key3) {

        Object retObject = null;
        TestEmbeddableA embeddableA = myMap.get(key1);
        if(embeddableA != null) {
            retObject = embeddableA.getValue(key2, key3);
        }
        return retObject;
    }

    public void putObject(String key1, String key2, String key3, Object value) {

        TestEmbeddableA embeddableA = myMap.get(key1);
        if(embeddableA == null) {
            embeddableA = new TestEmbeddableA();
            myMap.put(key1, embeddableA);
        }
        embeddableA.updateValue(key2, key3, value);
    }

    public int getFirstId() {
        return firstId;
    }

    public void setFirstId(int firstId) {
        this.firstId = firstId;
    }

    public String getSecondId() {
        return secondId;
    }

    public void setSecondId(String secondId) {
        this.secondId = secondId;
    }
}
